ReadExpr: misreads 2/3^4

06 Oct 2016 11:37 - John Abbott

Status: Closed Start date: 06 Oct 2016

Priority: Urgent Due date:  

Assignee: John Abbott % Done: 100%

Category: Maths Bugs Estimated time: 2.60 hours

Target version: CoCoALib-0.99550 spring 2017 Spent time: 2.50 hours

Description

After my change to ReadExpr so that it can read rational numbers, the fn now misreads "2/3^4" and produces 16/81 instead of 2/81.

Rectify!  And add a test!

Related issues:

Related to CoCoA-5 - Feature #909: ReadExpr: decimal point Closed 14 Jul 2016

Related to CoCoALib - Bug #936: ReadExpr: cannot handle exponent which is not... Closed 05 Oct 2016

History

#1 - 06 Oct 2016 11:38 - John Abbott

It is a slightly subtle bug: at first sight it seems reasonable that <constant>^<integer> should yield the obvious power of the constant, but this is not

how I read 2/3^4.

#2 - 07 Oct 2016 15:11 - John Abbott

- Related to Feature #909: ReadExpr: decimal point added

#3 - 07 Oct 2016 15:15 - John Abbott

- Status changed from New to In Progress

- Assignee set to John Abbott

- % Done changed from 0 to 10

I see no choice but to make 2/3^4 read as an expression div(2, power(3,4)), and this implies that all rationals expressed as explicit quotients have to

be read as an expression div(...,...).

#4 - 08 Oct 2016 21:55 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 10 to 90

I have fixed it now, and added a new test-RingElem5 for the function ReadExpr (for rational numbers).

Trickier than expected; also not so easy coming up with the various test cases.

#5 - 08 Oct 2016 22:10 - John Abbott

- Related to Bug #936: ReadExpr: cannot handle exponent which is not integer literal added

#6 - 09 Nov 2016 10:46 - John Abbott

- Target version changed from CoCoALib-0.99560 to CoCoALib-0.99550 spring 2017

#7 - 18 Nov 2016 22:23 - John Abbott
- Status changed from Feedback to Closed

- % Done changed from 90 to 100

- Estimated time set to 2.60 h
